/*** tree.pro ***/
/****************************************************************

     Turbo Prolog Toolbox
     (C) Copyright 1987 Borland International.

		Treemenu
****************************************************************/


PREDICATES
%  treemenu(SYMBOL,TREE,SELECTOR,KEY)
%  treeaction(SELECTOR)
  draw(symbol,TREE)
  writetext(ROW,COL,INTEGER,STRING,SELECTOR)
  treeline_ver(ROW,ROW,COL)
  treeline_ver1(ROW,ROW,COL)
  treeline_hor(COL,COL,ROW)
  treeline_hor1(COL,COL,ROW)
  scr_ch(ROW,COL,CHAR)  
  testkey(KEY,SELECTOR,KEY)
  lastinlist(ROW,ROWLIST)
  lastinlist(COL,COLLIST)
  incrow(ROW,ROW,COL,COL)
  listsum(ROWLIST,ROW)
  listsum(COLLIST,COL)
  treekeyact(KEY)
  just(ROW,COL)
  just1(ROW,COL,ROW,COL)
  just2(ROW,COL)
  nodelistlen(ROWLIST,INTEGER)
  nodelistlen(COLLIST,INTEGER)
  remove_treechoice
%  newupdate(DBASEDOM)
  treedrop(INTEGER,STRING,STRING)
  draw_char(ROW,COL,CHAR)
CLAUSES
draw_char(R,C,CHAR):-
	scrool,
	scr_char(R,C,CHAR),!.
draw_char(_,_,_).
/* draw vertical lines connecting elements in the tree */
  treeline_ver(R1,R2,C):-
  	treewindow(STROW,STCOL),           /* find the starting position */
  	makewindow(_,_,_,_,_,_,ROWS,COLS), /* returns the tree windows size */
  	C>=STCOL, C<STCOL+COLS-2, R1<STROW+ROWS-2,  
  	R2>=STROW, SLROW=STROW+ROWS-2,
	max(STROW,R1,STROW1), min(R2,SLROW,SLROW1),
	CC=C-STCOL, RR1=STROW1-STROW, RR2=SLROW1-STROW,
	treeline_ver1(RR1,RR2,CC),fail.
  treeline_ver(_,_,_).

  treeline_ver1(R1,R2,C):-
  	R2>R1, R=R1+1,
	draw_char(R1,C,''),
	treeline_ver1(R,R2,C).

/* draw horizontal lines connecting elements in the tree */
  treeline_hor(C1,C2,R):-
  	treewindow(STROW,STCOL), makewindow(_,_,_,_,_,_,ROWS,COLS),
	SLCOL=STCOL+COLS-2,
  	R>=STROW, R<STROW+ROWS-2, C1<SLCOL, C2>STCOL,
	max(STCOL,C1,STCOL1), min(C2,SLCOL,SLCOL1),
	RR=R-STROW, CC1=STCOL1-STCOL, CC2=SLCOL1-STCOL,
	treeline_hor1(CC1,CC2,RR),fail.
  treeline_hor(_,_,_).

  treeline_hor1(C1,C2,R):-
	C2>C1, C=C1+1,
	draw_char(R,C1,''),
	treeline_hor1(C,C2,R).

/* write a character in a tree window  */
  scr_ch(R,C,CH):-
  	treewindow(STROW,STCOL), makewindow(_,_,_,_,_,_,ROWS,COLS),
  	R>=STROW, R<STROW+ROWS-2, C>=STCOL, C<STCOL+COLS-2, !,
	RR=R-STROW, CC=C-STCOL,
	draw_char(RR,CC,CH).
  scr_ch(_,_,_).

  treedrop(0,TEXT,TEXT):-!.
  treedrop(N,TEXT,TEXT1):-frontstr(N,TEXT,_,TEXT1).

writetext(ROW,COL,ATTR,TEXT,SELECT):-
	str_len(TEXT,LEN),
  	treewindow(STROW,STCOL), makewindow(_,_,_,_,_,_,ROWS,COLS),
  	ROW>=STROW, ROW<STROW+ROWS-2, COL<STCOL+COLS-2, COL+LEN>STCOL,
  	REALROW=ROW-STROW,
  	RSTART=COL-STCOL,
  	REND=RSTART+LEN,
	VST=STCOL-STCOL, VEND=VST+COLS-2,
	max(RSTART,VST,RSTART1), min(REND,VEND,REND1),
	REALLEN=REND1-RSTART1,
	DROP=RSTART1-RSTART,
	treedrop(DROP,TEXT,TEXT1),
	field_str(REALROW,RSTART1,REALLEN,TEXT1),
	field_attr(REALROW,RSTART1,REALLEN,ATTR),
	cursor(R,C),
	R=REALROW,
	C>=RSTART1, C<RSTART1+REALLEN,!,
	field_attr(R,RSTART1,REALLEN,1),
	assert(treechoice(SELECT)).
  writetext(_,_,_,_,_).


  listsum(  [],0):-!.
  listsum([H|T],N):-listsum(T,N1),N=N1+H.

  incrow(ROW,NEW,COL,COL):-!,NEW=ROW+2.
  incrow(ROW,NEW,_,_):-NEW=ROW+2.
    
  lastinlist(RMAX,[RMAX]) :- !.
  lastinlist(RMAX,[_|T]) :- lastinlist(RMAX,T).

  nodelistlen([],0).
  nodelistlen([_|T],N):-
	nodelistlen(T,X),
	N=X+1.

  newupdate(_):-retract(treewindow(_,_)),fail.
  newupdate(X):-assert(X).
  
/* Cursor window control */
  just(R,C):-
  	trace(on),
	cursor(ROW,COL),       /* current cursor pos */
	RR=ROW+R, CC=COL+C,
	makewindow(_,_,_,_,_,_,ROWS,COLS),
	ROWSS=ROWS-3, COLSS=COLS-3,
	just1(RR,CC,ROWSS,COLSS).

/* move cursor and control windows */
  just1(R,C,_,_):-R<0,!,cursor(0,C),just2(R,0).
  just1(R,C,_,_):-C<0,!,cursor(R,0),just2(0,C).
  just1(R,C,ROWS,_):-R>ROWS,!,cursor(ROWS,C),DR=R-ROWS,just2(DR,0).
  just1(R,C,_,COLS):-C>COLS,!,cursor(R,COLS),DC=C-COLS,just2(0,DC).

/* scroll tree in window with cursor and update tree position */
  just2(DR,DC):-
  	assert(scrool),
  	del_mouse_cursor,
	scroll(DR,DC),  /* scroll is a Turbo Prolog standard predicate */
	dsp_mouse_cursor,
  	treewindow(R,C),!,
	CC=C+DC, RR=R+DR,
	newupdate(treewindow(RR,CC)), 
	fail.

/* Tree input key action */
  treekeyact(right)	:-just(0,1).
  treekeyact(ctrlright)	:-just(0,5).
  treekeyact(left)	:-just(0,-1).
  treekeyact(ctrlleft)	:-just(0,-5).
  treekeyact(up)	:-just(-1,0).
  treekeyact(pgup)	:-just(-5,0).
  treekeyact(down)	:-just(1,0).
  treekeyact(pgdn)	:-just(5,0).
  treekeyact(ctrlhome)	:-treewindow(R,C),!,RR=-R,CC=-C,just2(RR,CC).
  treekeyact(end)	:-cursor(_,C),makewindow(_,_,_,_,_,_,_,COLS),
			  DC=COLS-3-C,just(0,DC).
  treekeyact(home)	:-cursor(_,C),DC=-C,just(0,DC).
  treekeyact(esc).
  treekeyact(cr).
  treekeyact(fkey(10)).
  treekeyact(ins).
  treekeyact(del).
  treekeyact(ctrlbdel).
  treekeyact(fkey(1)):-help.
  treekeyact(fkey(4)).
  treekeyact(fkey(5)).
  treekeyact(fkey(6)).
  treekeyact(fkey(7)).

/*treekeyact(fkey(1)):-help.  If helpsystem is used */

  remove_treechoice:-retract(treechoice(_)),fail.
  remove_treechoice.
  
testkey(esc,0,esc):-!.
testkey(click,CHOICE,cr):-treekeyact(cr),treechoice(CHOICE),!.
testkey(KEY,CHOICE,KEY):-treekeyact(KEY),treechoice(CHOICE),!.

/*  DRAW TREE DOWN */
ifdef tree_down
PREDICATES
  draw_down(TREE,ROW,COL,COL,COL)
  draw_downlist(TREELIST,COLLIST,COLLIST,ROW,COL,COL)
  connect_nodesdown(ROW,ROW,COL,ROW,COLLIST)
  con_nodesdown(COL,ROW,COL,COL,ROW,COLLIST)
  cornerdown(COL,COL,COL,COL,CHAR)
  check_lastdown(COL,ROW,COLLIST)


CLAUSES
  draw_down(_,_,_,_,_):-keypressed,!,
  			complex_key(follow,KEY),
  			treekeyact(KEY),fail.
  draw_down(tree(NAME,_,SELECT,[]),CURROW,MAXCOL,NEWMAXCOL,MID):-!,
	str_len(NAME,LEN),
	NEWMAXCOL=MAXCOL+LEN+1,
	MID=MAXCOL+(LEN-1) div 2,
	writetext(CURROW,MAXCOL,112,NAME,SELECT).
  draw_down(tree(NAME,_,SELECT,TREELIST),CURROW,MAXCOL,NEWMAXCOL,RESCOL):-
	NEXTROW=CURROW+3,
	draw_downlist(TREELIST,[],NODECOLLIST,NEXTROW,MAXCOL,NEWMAXCOL0),
	nodelistlen(NODECOLLIST,LEN),
	listsum(NODECOLLIST,SUM),
	str_len(NAME,NAMELEN),
	RESCOL=SUM div LEN,
	JUST=RESCOL-NAMELEN div 2,
	max(MAXCOL,JUST,NAMESTART),
	writetext(CURROW,NAMESTART,112,NAME,SELECT),
	ROW1=CURROW+1,LLEN=LEN,
	connect_nodesdown(ROW1,NEXTROW,RESCOL,LLEN,NODECOLLIST),
	check_lastdown(RESCOL,ROW1,NODECOLLIST),
	NEWMAXCOL1=NAMESTART+NAMELEN+1,
	max(NEWMAXCOL0,NEWMAXCOL1,NEWMAXCOL).
	

  draw_downlist([],NODECOLLIST,NODECOLLIST,_,MAXCOL,MAXCOL).
  draw_downlist([H|T],NodeColList,ResNodeColList,CURROW,MAXCOL,MAXCOL2):-
	draw_down(H,CURROW,MAXCOL,MAXCOL1,NODECOL),
	draw_downlist(T,[NODECOL|NODECOLLIST],RESNODECOLLIST,CURROW,MAXCOL1,MAXCOL2).

  check_lastdown(COL,_,[COL|_]):-!.
  check_lastdown(COL,ROW,[_|LIST]):-!,check_lastdown(COL,ROW,LIST).
  check_lastdown(COL,ROW,_):-scr_ch(ROW,COL,'').

  connect_nodesdown(ROW,ROW1,COL,1,_) :-!,
        treeline_ver(ROW,ROW1,COL).
  connect_nodesdown(ROW,ROW1,COL,_,[CMAX|L]):-
        lastinlist(CMIN,[CMAX|L]),
        CC=CMIN+1,
        treeline_hor(CC,CMAX,ROW),
        con_nodesdown(COL,ROW,CMIN,CMAX,ROW1,[CMAX|L]).
  
  con_nodesdown(_,_,_,_,_,[]).
  con_nodesdown(COL,ROW,CMIN,CMAX,ROW1,[COL1|T]):-
	RR=ROW+1,
	treeline_ver(RR,ROW1,COL1),
	cornerdown(COL,CMIN,CMAX,COL1,CORNCHAR),
	scr_ch(ROW,COL1,CORNCHAR),
	con_nodesdown(COL,ROW,CMIN,CMAX,ROW1,T).

  cornerdown(MIN,MIN,_,MIN,'') :- !.
  cornerdown(MAX,_,MAX,MAX,'') :- !.
  cornerdown(_,MIN,_,MIN,'') :- !.
  cornerdown(_,_,MAX,MAX,'') :- !.
  cornerdown(MIDT,_,_,MIDT,'') :- !.
  cornerdown(_,_,_,_,'').
enddef
  treemenu(DIRECTION,TREE,CHOICE,OUTKEY) :-
  	assert(scrool),
  	repeat,
	remove_treechoice,
	draw(DIRECTION,TREE),
	retractall(scrool),
	complex_key(follow,KEY),
	testkey(KEY,CHOICE,OUTKEY),!.

/* DRAW TREE RIGHT */
ifdef tree_right
 include "..\\include\\treerigh.pro"
enddef
/* draw a tree in the selected direction */
CLAUSES

ifdef tree_down
 draw(down,TREE):-draw_down(TREE,0,0,_,_).
enddef
ifdef tree_right
 draw(right,TREE):-draw_right(TREE,0,_,0,_,0,5,_).
enddef
